#include "analyzer.h"

#include <fstream>
#include <stdexcept>

CAnalyzer::CAnalyzer(std::vector<double>&& numbers)
	: mNumbers(numbers)
{
}

CAnalyzer CAnalyzer::Create(const std::string& fileName)
{
	std::vector<double> numbers;

	// otevre soubor
	std::ifstream ifs(fileName, std::ios::in | std::ios::binary);

	if (!ifs.is_open())
		throw std::invalid_argument{ "Nelze otevrit soubor " + fileName };

	// zjisti velikost a pole cisel zvetsi, aby se tam cisla vesla
	ifs.seekg(0, std::ios::end);
	numbers.resize(ifs.tellg() / sizeof(double));
	ifs.seekg(0, std::ios::beg);

	// precte obsah souboru
	ifs.read(reinterpret_cast<char*>(numbers.data()), numbers.size() * sizeof(double));

	// overi, ze se precetlo vsechno
	if (ifs.gcount() != numbers.size() * sizeof(double))
		throw std::runtime_error{ "Nelze precist cisla ze souboru " + fileName };

	return CAnalyzer(std::move(numbers));
}

void CAnalyzer::Calculate_Density()
{
	// TODO
}

void CAnalyzer::Calculate_Distribution()
{
	// TODO
}

void CAnalyzer::Analyze_Distribution(double& mean, double& sigma) const noexcept
{
	// TODO
}

double CAnalyzer::Get_Percentile(unsigned char pct) const
{
	// TODO

	return 0;
}

size_t CAnalyzer::Get_Numbers_Above_Percentile(unsigned char pct) const
{
	// TODO

	return 0;
}
